PPI::Token::Prototype(3)

NAME
PPI::Token::Prototype - A subroutine prototype descriptor

INHERITANCE
  PPI::Token::End
  isa PPI::Token
      isa PPI::Element

SYNOPSIS
  sub ($@) prototype;

DESCRIPTION
Although it sort of looks like a list or condition, a subroutine prototype is a lot more like a string. Its job is to provide hints to the perl compiler on what type of arguments a particular subroutine expects, which the compiler uses to validate parameters at compile-time, and allows programmers to use the functions without explicit parameter braces.

Due to the rise of OO Perl coding, which ignores these prototypes, they are most often used to allow for constant-like things, and to "extend" the language and create things that act like keywords and core functions.

  # Create something that acts like a constant
  sub MYCONSTANT () { 10 }

  # Create the "any" core-looking function
  sub any (&@) { ... }

  if ( any { $_->cute } @babies ) {
        ...
  }

METHODS
This class provides one additional method beyond those defined by the PPI::Token and PPI::Element parent classes.

  prototype
The "prototype" accessor returns the actual prototype pattern, stripped of braces and any whitespace inside the pattern.

SUPPORT
See the support section in the main module.

AUTHOR
Adam Kennedy <adamk@cpan.org>

COPYRIGHT
Copyright 2001 - 2011 Adam Kennedy.

This program is free software; you can redistribute it and/or modify it under the same terms as Perl itself.

The full text of the license can be found in the LICENSE file included with this module.